{It came from Internet www.programmersheaven.com}
unit modex;
Interface

var
   {var for 640x320 256 color}
    VesaBankShift, CurrentBank: word;
    VesaBankProc: procedure;            { far pointer to a procedure }
{function for 640x480 256 color}
function InitVesa: boolean;
procedure InitModeVesa;
procedure CloseGraph;
procedure PutPixel256(x,y: word; color: byte);

{function for 320x200 256 color}
procedure InitMode13;  {Start Bios Mode 13h - 320x200x256}
procedure RestoreTextMode;  {Text mode}
procedure PSet(X, Y: Integer; Color: Byte);  {Set  pixel pada mode 13h}

Implementation
function InitVesa: boolean; assembler;
var
    VesaBuffer: array [0..255] of byte;
asm
        push    ss
        pop     es
        mov     ax,4F00h
        lea     di,[VesaBuffer]
        int     10h
        cmp     ax,004Fh                { is vesa supported? }
        jne     @bad
        mov     ax,4F01h
        mov     cx,101h
        int     10h
        cmp     ax,004Fh                { is 640x480x256 supported? }
        jne     @bad
        mov     ax,es:[di+4]
        mov     bx,es:[di+12]
        mov     dx,es:[di+14]
        xor     cx,cx
    @FindVesaBankShift:
        cmp     ax,64
        jae     @FoundVesaBankShift
        add     ax,ax
        inc     cx
        jmp     @FindVesaBankShift
    @FoundVesaBankShift:
        mov     [VesaBankShift],cx
        mov     [offset VesaBankProc+0],bx
        mov     [offset VesaBankProc+2],dx
        mov     al,TRUE
        jmp     @exit
    @bad:
        mov     al,FALSE
    @exit:
end;

procedure InitModeVesa; assembler;         { sets 640x480x256 mode }
asm
        mov     ax,4F02h
        mov     bx,101h
        int     10h
        xor     bx,bx
        xor     dx,dx
        mov     [CurrentBank],bx
        call    [VesaBankProc]
end;

procedure SetBank(num: word); assembler;
asm
        mov     dx,[num]
        mov     cx,[VesaBankShift]
        mov     [CurrentBank],dx
        xor     bx,bx
        shl     dx,cl
        call    [VesaBankProc]
end;

procedure CloseGraph; assembler;        { sets text mode }
asm
        mov     ax,3
        int     10h
end;


procedure PutPixel256(x,y: word; color: byte); assembler;
asm
        mov     ax,0A000h
        mov     es,ax

        mov     ax,640
        mov     di,[x]
        mul     [y]
        add     di,ax
        adc     dx,0
 
        cmp     dx,[CurrentBank]
        jz      @SameBank
        mov     cx,[VesaBankShift]  { set bank procedure inline }
        mov     [CurrentBank],dx
        xor     bx,bx
        shl     dx,cl
        call    [VesaBankProc]
    @SameBank:
        mov     al,[color]
        mov     es:[di],al
end;
 
procedure SlowPixel(x,y: word; color: byte); assembler;
asm
        mov     ah,0Ch
        mov     al,[color]
        mov     cx,[x]
        mov     dx,[y]
        xor     bx,bx
        int     10h
end;

procedure InitMode13;
   {Start Bios Mode 13h - 320x200x256}
   	Begin
         {Call service 00h of the BIOS interruption 10h.
			 Parameter AL = 13h(Video number)}
	     	ASM
         	xor AH, AH	{AH = 0h}
         	mov AL, 13h	{AL = 13h}
            int 10h		{Interrupsi 10h (Video Interrupt)}
         End;{Asm}
      End;{InitMode13}

   procedure RestoreTextMode;
   { Text mode}
   	Begin
         {Call service 00h of the BIOS interruption 10h.
			 Parameter AL = 3h(Video number)}
	     	ASM
         	xor AH, AH	{AH = 0h}
         	mov AL, 3h	{AL = 3h}
            int 10h		{Call Interrupt 10h (Video Interrupt)}
         End;{Asm}
      End;{RestoreTextMode}

   procedure PSet(X, Y: Integer; Color: Byte);
   var n1,n2 : integer;	{Set  pixel under mode 13h}
   	begin
         {Clipping to screen}
      	if (X > -1) and (X < 320) and
            (Y > -1) and (Y < 200) Then
            Begin
					{Now, you must set the position X + Y * 320 of the Video
					Memory Segment (A000h) to plot the point}
               ASM
                mov AX, Y               {AX = y}
                mov N1, AX		{N1 = Y}
               End;{ASM}
               N2 := N1;
               N1 := N1 shl 6;  {N1 = N1 * 64 }
               N2 := N2 shl 8;  {N2 = N2 * 256 }
               asm
                  mov AX, N1		{AX = AX * 64}
		  mov BX, N2		{BX = BX * 256}
                  add BX, AX		{BX = Y * 64 + Y * 256 = Y * 320}
                  add BX, X		{BX = BX + X}
                  mov AL, Color	{AL = Color}
                  {Now, put the point}    {put(x,y,color)}
                  mov DI, SEGA000{DI = A000h}
                  mov ES, DI		{ES = A000h, there are no other fast way to do this}
						mov ES:[BX], AL{It's done}
               end;
            End;{If}
      End;{Pset}


end.